## org.eclipse.uml2.codegen.ecore.genmodel
Interface GenFeature

All Superinterfaces:
  org.eclipse.emf.ecore.EObject, org.eclipse.emf.codegen.ecore.genmodel.GenBase, org.eclipse.emf.codegen.ecore.genmodel.GenFeature, org.eclipse.emf.codegen.ecore.genmodel.GenTypedElement, org.eclipse.emf.common.notify.Notifier

    public interface GenFeature

extends org.eclipse.emf.codegen.ecore.genmodel.GenFeature, GenTypedElement

A representation of the model object 'Gen Feature'.

The following features are supported:

- `Key`
- `Pluralization Exception`

See Also:
  `GenModelPackage.getGenFeature()`

Method Summary
`java.lang.String` `getFormattedKeyFeatureName(int index)`
`java.lang.String` `getFormattedKeyFeatureNames()`
`java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, int index)`
`java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, int index, boolean formal)`
`java.lang.String` `getKeyFeatureParameter(int index)` Deprecated.
`java.lang.String` `getKeyFeatureParameter(int index, boolean formal)` Deprecated.
`java.lang.String` `getKeyFeatureParameters()` Deprecated.
`java.lang.String` `getKeyFeatureParameters(boolean formal)` Deprecated.
`java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context)`
`java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, boolean formal)`
`java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getKeyGenFeatures()`
`java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getRedefinedGenFeatures()`
`java.lang.String` `getRedefinedListItemType()` Deprecated.
`java.lang.String` `getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenClass context)`
`java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsettedGenFeatures()`
`boolean` `hasStringTypeKeyGenFeature()`
`boolean` `isCached()`
`boolean` `isDuplicate()`
`boolean` `isEffectiveContainsSubset()`
`boolean` `isFactoryMethods()`
`boolean` `isKey()` Returns the value of the 'Key' attribute
`boolean` `isPluralizationException()` Returns the value of the 'Pluralization Exception' attribute
`boolean` `isRedefinition()`
`boolean` `isSubset()`
`boolean` `isUnion()`
`void` `setKey(boolean value)` Sets the value of the '`Key`' attribute
`void` `setPluralizationException(boolean value)` Sets the value of the '`Pluralization Exception`' attribute

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenFeature

`getAccessorName, getCapName, getChangeableFlag, getContainerClass, getContainmentFlag, getCreateChildValueLiteral, getDefaultValue, getDelegatedFeatures, getDelegatedFeatures, getDelegateFeature, getDerivedFlag, getEcoreFeature, getEDefault, getFeatureAccessorName, getFeatureKind, getFormattedName, getGenClass, getGenPackage, getGetAccessor, getGetArrayAccessor, getIDFlag, getImportedMetaType, getIsName, getKeys, getMetaType, getModelInfo, getName, getProperty, getPropertyCategory, getPropertyDescription, getPropertyFilterFlags, getPropertyImageName, getQualifiedFeatureAccessor, getQualifiedFeatureAccessorName, getQualifiedModelInfo, getResolveProxiesFlag, getReverse, getSafeName, getSafeNameAsEObject, getStaticDefaultValue, getTransientFlag, getUncapName, getUnsettableFlag, getUpperName, getVolatileFlag, hasDelegateFeature, hasEDefault, initialize, isBasicGet, isBasicSet, isBasicUnset, isBidirectional, isChangeable, isChildren, isContainer, isContains, isCreateChild, isDerived, isEffectiveContains, isESetField, isESetFlag, isField, isFlag, isGet, isID, isIsSet, isNotify, isProperty, isPropertyMultiLine, isPropertySortChoices, isReferenceType, isResolveProxies, isSet, isSetCreateChild, isSetDefaultValue, isSuppressedGetVisibility, isSuppressedIsSetVisibility, isSuppressedSetVisibility, isSuppressedUnsetVisibility, isTested, isUnset, isUnsettable, isVolatile, reconcile, setChildren, setCreateChild, setEcoreFeature, setGenClass, setNotify, setProperty, setPropertyCategory, setPropertyDescription, setPropertyMultiLine, setPropertySortChoices, unsetCreateChild`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenTypedElement

`getEcoreModelElement, getEffectiveComplianceLevel, getEObjectCast, getGenClassType, getGenDataTypeType, getGenEnumType, getImportedEffectiveFeatureMapWrapperClass, getImportedEffectiveFeatureMapWrapperInternalInterface, getImportedInternalType, getImportedInternalType, getImportedMapEntryType, getImportedMapKeyType, getImportedMapTemplateArguments, getImportedMapValueType, getImportedType, getImportedType, getInternalTypeCast, getListItemType, getListItemType, getListTemplateArguments, getLowerBound, getMapEntryTypeGenClass, getMapGenClass, getMapItemType, getNonEObjectInternalTypeCast, getNonEObjectInternalTypeCast, getObjectType, getObjectType, getOrderedFlag, getPrimitiveValueFunction, getQualifiedListItemType, getQualifiedListItemType, getRawBoundType, getRawImportedBoundType, getRawImportedType, getRawListItemType, getRawType, getRawTypeCast, getType, getType, getTypeClassifier, getTypeClassifierAccessorName, getTypeGenClass, getTypeGenClassifier, getTypeGenDataType, getTypeGenEnum, getTypeGenPackage, getUniqueFlag, getUpperBound, hasGenericType, isBooleanType, isEffectiveSuppressEMFTypes, isEnumBasedType, isEnumType, isFeatureMapType, isFeatureMapWrapped, isListDataType, isListType, isMapType, isPrimitiveType, isStringBasedType, isStringType, isUncheckedCast, isUncheckedCast, isUnique, isWrappedFeatureMapType`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenBase

`canGenerate, canGenerateEdit, canGenerateEditor, canGenerateSchema, canGenerateTests, capName, format, gen, genEdit, genEditor, generate, generate, generateEdit, generateEdit, generateEditor, generateEditor, generateSchema, generateSchema, generateTests, generateTests, genSchema, genTests, getCopyright, getDocumentation, getGenAnnotation, getGenAnnotations, getGenModel, hasCopyright, hasDocumentation, reconcile, safeName, uncapName, uncapPrefixedName`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenTypedElement

`getEcoreModelElement, getEffectiveComplianceLevel, getEObjectCast, getGenClassType, getGenDataTypeType, getGenEnumType, getImportedEffectiveFeatureMapWrapperClass, getImportedEffectiveFeatureMapWrapperInternalInterface, getImportedInternalType, getImportedInternalType, getImportedMapEntryType, getImportedMapKeyType, getImportedMapTemplateArguments, getImportedMapValueType, getImportedType, getImportedType, getInternalTypeCast, getListItemType, getListItemType, getListTemplateArguments, getLowerBound, getMapEntryTypeGenClass, getMapGenClass, getMapItemType, getNonEObjectInternalTypeCast, getNonEObjectInternalTypeCast, getObjectType, getObjectType, getOrderedFlag, getPrimitiveValueFunction, getQualifiedListItemType, getQualifiedListItemType, getRawBoundType, getRawImportedBoundType, getRawImportedType, getRawListItemType, getRawType, getRawTypeCast, getType, getType, getTypeClassifier, getTypeClassifierAccessorName, getTypeGenClass, getTypeGenClassifier, getTypeGenDataType, getTypeGenEnum, getTypeGenPackage, getUniqueFlag, getUpperBound, hasGenericType, isBooleanType, isEffectiveSuppressEMFTypes, isEnumBasedType, isEnumType, isFeatureMapType, isFeatureMapWrapped, isListDataType, isListType, isMapType, isPrimitiveType, isStringBasedType, isStringType, isUncheckedCast, isUncheckedCast, isUnique, isWrappedFeatureMapType`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenBase

`canGenerate, canGenerateEdit, canGenerateEditor, canGenerateSchema, canGenerateTests, capName, format, gen, genEdit, genEditor, generate, generate, generateEdit, generateEdit, generateEditor, generateEditor, generateSchema, generateSchema, generateTests, generateTests, genSchema, genTests, getCopyright, getDocumentation, getGenAnnotation, getGenAnnotations, getGenModel, hasCopyright, hasDocumentation, reconcile, safeName, uncapName, uncapPrefixedName`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.emf.codegen.ecore.genmodel.GenBase

`canGenerate, canGenerateEdit, canGenerateEditor, canGenerateSchema, canGenerateTests, capName, format, gen, genEdit, genEditor, generate, generate, generateEdit, generateEdit, generateEditor, generateEditor, generateSchema, generateSchema, generateTests, generateTests, genSchema, genTests, getCopyright, getDocumentation, getGenAnnotation, getGenAnnotations, getGenModel, hasCopyright, hasDocumentation, reconcile, safeName, uncapName, uncapPrefixedName`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### isKey

    boolean isKey()

  Returns the value of the 'Key' attribute.

  If the meaning of the 'Key' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Key' attribute.
  See Also:
    `setKey(boolean)`, `GenModelPackage.getGenFeature_Key()`

### setKey

    void setKey(boolean value)

  Sets the value of the '`Key`' attribute.

  Parameters:
    `value` - the new value of the 'Key' attribute.
  See Also:
    `isKey()`

### isPluralizationException

    boolean isPluralizationException()

  Returns the value of the 'Pluralization Exception' attribute.

  If the meaning of the 'Pluralization Exception' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Pluralization Exception' attribute.
  See Also:
    `setPluralizationException(boolean)`, `GenModelPackage.getGenFeature_PluralizationException()`

### setPluralizationException

    void setPluralizationException(boolean value)

  Sets the value of the '`Pluralization Exception`' attribute.

  Parameters:
    `value` - the new value of the 'Pluralization Exception' attribute.
  See Also:
    `isPluralizationException()`

### isCached

    boolean isCached()

### isDuplicate

    boolean isDuplicate()

### isUnion

    boolean isUnion()

### isSubset

    boolean isSubset()

### isEffectiveContainsSubset

    boolean isEffectiveContainsSubset()

### isFactoryMethods

    boolean isFactoryMethods()

### getSubsettedGenFeatures

    java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsettedGenFeatures()

### isRedefinition

    boolean isRedefinition()

### getRedefinedGenFeatures

    java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getRedefinedGenFeatures()

### getRedefinedListItemType

    java.lang.String getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenClass context)

  Since:
    1.3

### getRedefinedListItemType

    @Deprecated
    java.lang.String getRedefinedListItemType()

  Deprecated.

  Use `getRedefinedListItemType(GenClass)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getRedefinedListItemType(getGenClass())`.

  See Also:
    `getRedefinedListItemType(GenClass)`

### getKeyGenFeatures

    java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getKeyGenFeatures()

### hasStringTypeKeyGenFeature

    boolean hasStringTypeKeyGenFeature()

### getKeyFeatureParameter

    java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                            int index)

  Since:
    1.3

### getKeyFeatureParameter

    @Deprecated
    java.lang.String getKeyFeatureParameter(int index)

  Deprecated.

  Use `getKeyFeatureParameter(GenClass, int)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameter(getGenClass(), index)`.

  See Also:
    `getKeyFeatureParameter(GenClass, int)`

### getKeyFeatureParameter

    java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                            int index,
                                            boolean formal)

  Since:
    1.3

### getKeyFeatureParameter

    @Deprecated
    java.lang.String getKeyFeatureParameter(int index,
                                                       boolean formal)

  Deprecated.

  Use `getKeyFeatureParameter(GenClass, int, boolean)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameter(getGenClass(), index, formal)`.

  See Also:
    `#getKeyFeatureParameter(GenClass, boolean)`

### getKeyFeatureParameters

    java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context)

  Since:
    1.3

### getKeyFeatureParameters

    @Deprecated
    java.lang.String getKeyFeatureParameters()

  Deprecated.

  Use `getKeyFeatureParameters(GenClass)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameters(getGenClass())`.

  See Also:
    `getKeyFeatureParameters(GenClass)`

### getKeyFeatureParameters

    java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                             boolean formal)

  Since:
    1.3

### getKeyFeatureParameters

    @Deprecated
    java.lang.String getKeyFeatureParameters(boolean formal)

  Deprecated.

  Use `getKeyFeatureParameters(GenClass, boolean)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameter(getGenClass(), formal)`.

  See Also:
    `getKeyFeatureParameters(GenClass, boolean)`

### getFormattedKeyFeatureName

    java.lang.String getFormattedKeyFeatureName(int index)

### getFormattedKeyFeatureNames

    java.lang.String getFormattedKeyFeatureNames()

Copyright 2003, 2007 IBM Corporation and others. All Rights Reserved.